'This is a timed demo for byte array to text conversion
'It downloads a 200kb image and converts it into a string,
'first with the control, then internally with VBScript.
'The string is NOT saved to disk, but it could be saved
'with Scripting.FileSystemObject TextStream methods.
'For reference, my AMD 1500 took 177 seconds with the control, 
'and 406 seconds with VBScript! Saving the array to disk 
'takes virtually no time.

Dim web, byt, strWebPage, varByteArray, objArrayFunctions, strData, dtStart
Const WinHttpRequestOption_EnableRedirects = 6

    'First download a large binary object for testing
    Status "Downloading"
    Set web = CreateObject("WinHttp.WinHttpRequest.5.1")
    web.Option(WinHttpRequestOption_EnableRedirects) = True
    web.Open "GET", "http://www.powerpointart.com/free-wtc-backgrounds/wtc-wet-us-flag.jpg", False
    web.Send
    varByteArray = web.ResponseBody
    
    'Now save it to disk
    Status "Saving to disk"
    dtStart = Now()
    Set objArrayFunctions = CreateObject("ByteArray.Functions")
    objArrayFunctions.ToFile varByteArray, FileNameLikeMine("jpg")
    MsgBox DateDiff("s", dtStart, Now()) & " seconds to save to disk"

    'Now convert it into a string with the control
    Status "Converting to text (with control)"
    dtStart = Now()
    Set objArrayFunctions = CreateObject("ByteArray.Functions")
    strData = objArrayFunctions.ToText(varByteArray)
    MsgBox DateDiff("s", dtStart, Now()) & " seconds to convert with control"
    
    'Now convert it into a string with VBScript
    Status "Converting to text (with VBS)"
    dtStart = Now()
    strData = ""
    For lngCounter = 0 to UBound(varByteArray)
        strData = strData & Chrw(Ascw(Chr(Ascb(Midb(varByteArray,lngCounter+1,1)))))
    Next
    MsgBox DateDiff("s", dtStart, Now()) & " seconds to convert with VBScript"


Function FileNameLikeMine(strFileExtension) 'As String
'Returns a file name the same as the script name except
'for the file extension. 
Dim fs 'As Object
Dim strExtension 'As String
    Set fs = CreateObject("Scripting.FileSystemObject")
    strExtension = strFileExtension
    If Len(strExtension) < 1 Then strExtension = "txt"
    If strExtension = "." Then strExtension = "txt"
    If Left(strExtension,1) = "." Then strExtension = Mid(strExtension, 2)
    FileNameLikeMine = Left(Wscript.ScriptFullName, InstrRev(Wscript.ScriptFullName, ".")) & strExtension
End Function

Sub Status(strMessage)
    If Lcase(Right(Wscript.FullName, 12)) = "\cscript.exe" Then
        Wscript.Echo strMessage
    End If
End Sub
